/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "BalloonEvent.h"

CBalloonEvent::CBalloonEvent()
	: g_mDoUnlock(FALSE)
	, g_evBalloon(FALSE, FALSE)
{
}

CBalloonEvent::~CBalloonEvent()
{
}

void CBalloonEvent::SetBalloonDiscard()
{
	CSingleLock lock(&m_CritSection, TRUE);
	g_mDoUnlock = FALSE;
	lock.Unlock();
	g_evBalloon.SetEvent();
}

void CBalloonEvent::SetBalloonClick()
{
	CSingleLock lock(&m_CritSection, TRUE);
	g_mDoUnlock = TRUE;
	lock.Unlock();
	g_evBalloon.SetEvent();
}

void CBalloonEvent::WaitForBalloonEvent()
{
	::WaitForSingleObject(g_evBalloon.m_hObject, 40000);
	g_evBalloon.ResetEvent();
}

BOOL CBalloonEvent::ShallUnlock() const
{
	return g_mDoUnlock;
}

void CBalloonEvent::Reset()
{
	CSingleLock lock(&m_CritSection, TRUE);
	g_mDoUnlock = FALSE;
}

