/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2014 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

class CPageantWnd;

class CCygSock : public CAsyncSocket
{
private:
	CPageantWnd *m_pAgentWnd;
	CString m_strSockpath;
	CString m_strSockaddr;
	UINT m_uPort;

	int m_iConnectSecret[4];
public:
	CCygSock();

	virtual ~CCygSock();
	virtual void OnAccept(int nErrorCode);

	virtual BOOL Create(const CString &);
	virtual void Close();

	void SetAgentWnd(CPageantWnd *);
	BOOL CheckSecret(const int *out);
	void GetSecret(int *out);
};


