/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

#include "StdAfx.h"
#include <map>
#include "BalloonEvent.h"

class CKeePassExtensions
{
private:
	static std::map<HWND,CKeePassExtensions*> c_mapWindows;
	static LRESULT KeePassWinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static CCriticalSection c_mapProtection;

	HWND m_hWnd;
	CBalloonEvent m_BalloonEvent;
	WNDPROC g_pOldWndProc;
public:
	CKeePassExtensions(HWND hWnd);
	~CKeePassExtensions();

	BOOL Hook();
	BOOL Unhook();
	BOOL ShowBalloon(const LPCTSTR info, const LPCTSTR title, UINT timeout = 5000, DWORD flags = NIIF_INFO);
	BOOL ShowBalloonAndWaitForAnswer(const LPCTSTR info, const LPCTSTR title, UINT timeout = 5000, DWORD flags = NIIF_INFO);
	void UnlockKeepass();

};
