/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "stdafx.h"
#include "PageantThread.h"
#include "PageantWnd.h"

// CPageantThread

IMPLEMENT_DYNCREATE(CPageantThread, CWinThread)

CPageantThread::CPageantThread()
	: m_bStarted(FALSE)
{
	m_bAutoDelete = FALSE;
}

CPageantThread::~CPageantThread()
{
}

BOOL CPageantThread::InitInstance()
{
	AfxSocketInit();
	srand((unsigned)time(NULL));

	m_bStarted = TRUE;
	CPageantWnd *wnd = new CPageantWnd();
	this->m_pMainWnd = wnd;
	m_evStartSuccessful.SetEvent();

	wnd->CreateCygSocket();

	return TRUE;
}

int CPageantThread::ExitInstance()
{
	if(m_pMainWnd)
	{
		delete m_pMainWnd;
		m_pMainWnd = 0;
	}
	m_bStarted = FALSE;
	return CWinThread::ExitInstance();
}

BOOL CPageantThread::StopThread()
{
	if(!m_pMainWnd)
		return FALSE;

	m_pMainWnd->SendMessage(WM_CLOSE);

	if(WaitForSingleObject(m_hThread, 2000) == WAIT_TIMEOUT)
	{
		return FALSE;
	}

	return TRUE;
}

BOOL CPageantThread::KillThread()
{
	return TerminateThread(m_hThread, 1);
}

BOOL CPageantThread::IsRunning() const
{
	return m_bStarted;
}

BEGIN_MESSAGE_MAP(CPageantThread, CWinThread)
END_MESSAGE_MAP()


// CPageantThread-Meldungshandler
