/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

#include "CygSock.h"

class CCygSockChannel;

class CPageantWnd : public CFrameWnd
{
	DECLARE_DYNAMIC(CPageantWnd)
public:
	CPageantWnd();
	virtual ~CPageantWnd();

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnClose();
	void CreateCygSocket();
	void OnCygReceive(CCygSockChannel *sock);
	void OnCygAccept(void);

private:
	BOOL UnlockKeePass(const CString &strMethod, const CString &strModuleName);
	PSID get_default_sid();
	PSID get_user_sid();

	BOOL m_bConfBalloonReq;
	BOOL m_bConfBalloonInfo;
	BOOL m_bConfCygEnable;
	CString m_strConfSockPath;
	CCygSock m_sCygSock;
};


