/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

#include "KeePassLibCpp/SDK/KpSDK.h"
#include "PageantThread.h"

#define MENUITEMCOUNT	3

#define ID_FILE_LOCK		32867
#define WM_MY_SYSTRAY_NOTIFY (WM_APP + 10)
#define IDR_SYSTRAY_MENU  157//8463

#define PUTTY_APPNAME	_T("Pageant")
#define AGENT_COPYDATA_ID 0x804e50ba

#define CONF_BALOON_REQ					_T("PuttyAgent_BalloonReq")
#define CONF_BALOON_REQ_DEF				TRUE
#define CONF_BALOON_INFO				_T("PuttyAgent_BalloonInfo")
#define CONF_BALOON_INFO_DEF			TRUE
#define CONF_CYG_ENABLE					_T("PuttyAgent_CygwinEnable")
#define CONF_CYG_ENABLE_DEF				FALSE
#define CONF_CYG_SOCKPATH				_T("PuttyAgent_SockPath")

KP_EXPORT HRESULT KP_API KP_I_INITIALIZELIB_DECL(IKpUnknown* pAPI);
KP_EXPORT HRESULT KP_API KP_I_RELEASELIB_DECL(IKpUnknown* pAPI);

KP_EXPORT HRESULT KP_API KP_I_CREATEINSTANCE_DECL(REFIID riid, void** ppvObject,
	IKpUnknown* pAPI);

class PuttyAgent : public IKpPlugin
{
public:
	PuttyAgent();
	virtual ~PuttyAgent();

	KP_DECL_IUNKNOWN;

	STDMETHODIMP_(BOOL) OnMessage(DWORD dwCode, LPARAM lParamW, LPARAM lParamL);

	STDMETHODIMP_(LPCTSTR) GetProperty(LPCTSTR lpName);
	STDMETHODIMP SetProperty(LPCTSTR lpName, LPCTSTR lpValue);

	STDMETHODIMP_(DWORD) GetMenuItemCount();
	STDMETHODIMP_(KP_MENU_ITEM*) GetMenuItems();

	CPageantThread *m_pThread;

private:
	KP_DECL_STDREFIMPL;

	KP_MENU_ITEM m_menuItems[MENUITEMCOUNT];

	void UpdateKeys();
	void StartAgent();
	BOOL StopAgent();
	void ShowSettings(void);
};

