/*
  PuttyAgent plugin for KeePass 1
  Copyright (C) 2011 Nikolaus Hammler <nikolaus@hammler.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "stdafx.h"
#include "PuttyAgent.h"
#include "ViewKeysDlg.h"

IMPLEMENT_DYNAMIC(CViewKeysDlg, CDialog)
CViewKeysDlg::CViewKeysDlg(CWnd* pParent /*=NULL*/, CKeyList &keyList)
	: CDialog(CViewKeysDlg::IDD, pParent)
	, m_keyList(keyList)
{
}

CViewKeysDlg::~CViewKeysDlg()
{
}

void CViewKeysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, 100, m_ctrlKeys);
}


BEGIN_MESSAGE_MAP(CViewKeysDlg, CDialog)
END_MESSAGE_MAP()


// CViewKeysDlg-Meldungshandler

BOOL CViewKeysDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int count = static_cast<int>(m_keyList.GetCount());
	for(int i = 0; i < count; i++) {
		this->m_ctrlKeys.AddString(m_keyList.GetAt(i));
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// AUSNAHME: OCX-Eigenschaftenseite muss FALSE zurckgeben.
}
